Public Class Druckdialog


    'Beispiel Code 2. SEK 2008
    'Bernd Jungbluth - info@berndjungbluth.de

    'Bei dem Code handelt sich um einen Beispielcode.
    'Der Autor bernimmt keine Verantwortung fr irgendeinen Schaden, der durch die Benutzung 
    'des Beispielcodes auftreten knnte. 
    'Der Autor kann fr etwaige Fehler im Programm nicht haftbar gemacht werden. 

    Private Sub Druckdialog_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            cboFormat.SelectedItem = "Anzeigen"
            cboBerichte.SelectedItem = "Kunden"
        Catch ex As Exception
            MsgBox(Err.Number.ToString & " - " & Err.Description)
        End Try
    End Sub

    Private Sub cboBerichte_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboBerichte.SelectedIndexChanged
        Try
            If cboBerichte.SelectedItem = "Kunden" Or cboBerichte.SelectedItem = "Produkte" Then
                lblDatum.Enabled = False
                txtDatum.Enabled = False
                txtDatum.Text = ""
                lblLand.Enabled = False
                cboLand.Enabled = False
                cboLand.SelectedItem = ""
            Else
                lblDatum.Enabled = True
                txtDatum.Enabled = True
                txtDatum.Text = "01.01.1996"
                lblLand.Enabled = True
                cboLand.Enabled = True
                cboLand.SelectedItem = "Austria"
            End If
        Catch ex As Exception
            MsgBox(Err.Number.ToString & " - " & Err.Description)
        End Try
    End Sub

    Private Sub cmdDrucken_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDrucken.Click

        Try
            If txtDatum.Enabled Then
                sBerichteUmsatz()
            Else
                sBerichteListen()
            End If
        Catch ex As Exception
            MsgBox(Err.Number.ToString & " - " & Err.Description)
        End Try

    End Sub

    Private Sub sBerichteListen()

        'Startet den Bericht ber die Webservice-Schnittstelle

        'Pfad des Berichts
        Dim strPfad As String = "/SEK/Listen/"
        'Name des Berichts
        Dim strBericht As String = cboBerichte.SelectedItem
        'Ausgabeformat des Berichts
        Dim strFormat As String = cboFormat.SelectedItem


        Try
            If strFormat = "Anzeigen" Then
                'Berichtsanzeige wird von Webservice nicht untersttzt, also ber URL
                'Nur hier wird der Weg zum Berichtsserver bentigt, da er bei der
                'Webservice-Methode bereits ber das Einbinden des Webservice bekannt ist
                Dim strReportServer As String = "http://localhost/reportserver$sql2005?"

                'Leerzeichen mssen im Link ein "+" sein
                strBericht = Replace(strBericht, " ", "+")
                'Aufruf der Berichtsanzeige
                System.Diagnostics.Process.Start(strReportServer & strPfad & strBericht)

            Else

                'Render-Parameter 
                Dim strExtension As String = String.Empty
                Dim strDeviceInfo As String = "<DeviceInfo><NoHeader>True</NoHeader></DeviceInfo>"
                Dim strMimeType As String = String.Empty
                Dim strEncoding As String = String.Empty
                Dim results() As [Byte]

                'Berichtsausfhrung
                Dim rs As New Berichte.ReportExecutionService

                'Berechtigungen
                rs.Credentials = System.Net.CredentialCache.DefaultCredentials

                'Ausgabeformat auswerten
                Select Case strFormat
                    Case "CSV"
                        strExtension = "csv"
                    Case "Excel"
                        strExtension = "xls"
                    Case "HTML"
                        strExtension = "html"
                        strFormat = "HTML4.0"
                    Case "Image als JPEG"
                        strExtension = "jpg"
                        strFormat = "Image"
                        strMimeType = "JPEG"
                    Case "Image als TIFF"
                        strExtension = "tif"
                        strFormat = "Image"
                    Case "PDF"
                        strExtension = "pdf"
                    Case "XML"
                        strExtension = "xml"
                End Select

                'Bericht laden
                rs.LoadReport(strPfad & strBericht, Nothing)

                'Bericht rendern
                results = rs.Render(strFormat, strDeviceInfo, strExtension, strMimeType, _
                                    strEncoding, Nothing, Nothing)
                'Bericht ausgeben
                Dim strDatei As String = "F:\SSRS\Export\" & cboBerichte.SelectedItem & " vom " & _
                    Format(rs.GetExecutionInfo.ExecutionDateTime, "yyyyMMdd") & "." & strExtension

                Dim stream As System.IO.FileStream = System.IO.File.OpenWrite(strDatei)
                stream.Write(results, 0, results.Length)
                stream.Close()

                MsgBox("Der Bericht """ & strDatei & """ wurde am " & _
                       Format(rs.GetExecutionInfo.ExecutionDateTime, "dd.MM.yyyy") & " als " & _
                       strExtension & "-Datei im '" & strMimeType & _
                       "'-Format " & _
                       IIf(strEncoding = String.Empty, "", "mit einer '" & strEncoding & "'-Codierung ") & _
                       "gerendert.")

            End If
        Catch ex As Exception
            MsgBox(Err.Description)
        End Try

    End Sub

    Private Sub sBerichteUmsatz()

        'Pfad des Berichts
        Dim strPfad As String = "/SEK/Umsatz/"
        'Name des Berichts
        Dim strBericht As String = cboBerichte.SelectedItem
        'Ausgabeformat des Berichts
        Dim strFormat As String = cboFormat.SelectedItem

        Try
            If strFormat = "Anzeigen" Then
                'Berichtsanzeige wird von Webservice nicht untersttzt, also ber URL
                'Nur hier wird der Weg zum Berichtsserver bentigt, da er bei der
                'Webservice-Methode bereits ber das Einbinden des Webservice bekannt ist
                Dim strReportServer As String = "http://localhost/reportserver$sql2005?"

                'Leerzeichen mssen im Link ein "+" sein
                strBericht = Replace(strBericht, " ", "+")

                'Parameter 
                Dim strParameter As String = ""
                If IsDate(txtDatum.Text) Then
                    strParameter = "&parVonDatum=" & Replace(txtDatum.Text, ".", "/") & _
                                   "&rc:ParameterLanguage=de-de"
                End If
                If cboLand.SelectedItem <> Nothing Then
                    strParameter = strParameter & _
                                   "&parLand=" & cboLand.SelectedItem
                End If

                'Aufruf der Berichtsanzeige
                System.Diagnostics.Process.Start(strReportServer & strPfad & strBericht & strParameter)

            Else
                'Render-Parameter 
                Dim strExtension As String = String.Empty
                Dim strDeviceInfo As String = "<DeviceInfo><NoHeader>True</NoHeader></DeviceInfo>"
                Dim strMimeType As String = String.Empty
                Dim strEncoding As String = String.Empty
                Dim results() As [Byte]

                'Berichtsparameter
                Dim parValue(1) As Berichte.ParameterValue
                parValue(0) = New Berichte.ParameterValue
                parValue(0).Name = "parVonDatum"
                parValue(0).Value = txtDatum.Text
                parValue(1) = New Berichte.ParameterValue()
                parValue(1).Name = "parLand"
                parValue(1).Value = cboLand.SelectedItem

                'Ausgabeformat auswerten
                Select Case strFormat
                    Case "CSV"
                        strExtension = "csv"
                    Case "Excel"
                        strExtension = "xls"
                    Case "HTML"
                        strExtension = "html"
                        strFormat = "HTML4.0"
                    Case "Image als JPEG"
                        strExtension = "jpg"
                        strFormat = "Image"
                        strMimeType = "JPEG"
                    Case "Image als TIFF"
                        strExtension = "tif"
                        strFormat = "Image"
                    Case "PDF"
                        strExtension = "pdf"
                    Case "XML"
                        strExtension = "xml"
                End Select

                'Berichtsausfhrung
                Dim rs As New Berichte.ReportExecutionService

                'Berechtigungen
                rs.Credentials = System.Net.CredentialCache.DefaultCredentials

                'Bericht laden
                rs.LoadReport(strPfad & strBericht, Nothing)

                'Paramter bergeben
                rs.SetExecutionParameters(parValue, "de-DE")

                'Bericht rendern
                results = rs.Render(strFormat, strDeviceInfo, strExtension, strMimeType, _
                                    strEncoding, Nothing, Nothing)

                'Bericht ausgeben
                Dim strDatum As String = Format(rs.GetExecutionInfo.ExecutionDateTime, "dd.MM.yyyy")
                Dim strDatei As String = "F:\SSRS\Export\Bestellungen vom " & txtDatum.Text & " bis " & _
                                         Format(Today(), "dd.MM.yyyy") & "." & strExtension
                Dim stream As System.IO.FileStream = System.IO.File.OpenWrite(strDatei)
                stream.Write(results, 0, results.Length)
                stream.Close()

                'Information ber Berichtsgenerierung
                MsgBox("Der Bericht """ & strDatei & """ wurde am " & strDatum & " als " & _
                       strExtension & "-Datei im '" & strMimeType & "'-Format gerendert.")

            End If

        Catch ex As Exception
            MsgBox(Err.Number.ToString & " - " & Err.Description)
        End Try

    End Sub




End Class
